/** Implémentation de la Calculette Capricieuse
 *
 * @see https://redmine.ryxeo.com/projects/leterrier-calc-cap/wiki
 * @author 2010 Jean-Louis Frucot
 * @see The GNU Public License (GPL)
 */

/**
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
* for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/


#include "editeurtouche.h"
#include "ui_editeurtouche.h"
#include "mainwindow.h"
#include <QDebug>

EditeurTouche::EditeurTouche(QString &typeTouche, QString &valeurAffichee, QString &valeurEffective, int &nbFois, QWidget *parent) :
    QDialog(parent),
    ui(new Ui::EditeurTouche())
{
    ui->setupUi(this);
    //ui->leValeurAffichee->setText(valeurAffichee);
    this->setWindowTitle(trUtf8("Touche")+" "+valeurAffichee);
//    if(typeTouche==("chiffre"))
//    {
//        ui->leValeurAffichee->setText(valeurAffichee);
//        ui->leValeurEffective->setText(valeurEffective);
//        //ui->sbValeurEffective->setValue(valeurEffective.toInt());
//    }
//    else
//    {
//        ui->leValeurAffichee->setText(valeurAffichee);
//        ui->leValeurEffective->setText(valeurEffective);
//    }
    ui->leValeurAffichee->setText(valeurAffichee);
    ui->leValeurEffective->setText(valeurEffective);
    // Afficher les types de touche traduits
    ui->cbTypeTouche->addItem(trUtf8("Chiffre"));
    ui->cbTypeTouche->addItem(trUtf8("Mémoire"));
    ui->cbTypeTouche->addItem(trUtf8("Opérateur"));
    ui->cbTypeTouche->addItem(trUtf8("Égale"));
    ui->cbTypeTouche->addItem("(");
    ui->cbTypeTouche->addItem(")"); // Chercher l'index du type dans le tableau tabType
    // pour préselectionner le bon type
    tabType[0]="chiffre";
    tabType[1]="memoire";
    tabType[2]="operateur";
    tabType[3]="egale";
    tabType[4]="(";
    tabType[5]=")";
    int i=0;
    while (typeTouche!=tabType[i] ){i++;};
    ui->cbTypeTouche->setCurrentIndex(i);

    // Création de la liste des nb de fois possibles.
    for (int i=0;i<11;i++)
    {
        ui->cbNbFois->addItem(QString::number(i));
    }
    ui->cbNbFois->addItem(trUtf8("Illimité"));

    // Préselection de l'index
    if (nbFois>10)
    {
        ui->cbNbFois->setCurrentIndex(11);
    }
    else
    {
        ui->cbNbFois->setCurrentIndex(nbFois);
    }
}

EditeurTouche::~EditeurTouche()
{
    delete ui;
}

void EditeurTouche::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}


void EditeurTouche::on_buttonBox_accepted()
{
     valAffichee=ui->leValeurAffichee->text();
     valEffective=ui->leValeurEffective->text();
     typeTouch=tabType[ui->cbTypeTouche->currentIndex()];
    if(ui->cbNbFois->currentIndex()==11)
    {
        nb=32000;
    }
    else
    {
        nb=ui->cbNbFois->currentText().toInt();
    }
}

void EditeurTouche::on_cbTypeTouche_currentIndexChanged(int index)
{
    EditeurTouche::activeChamps(index);
    switch(index)
    {
    case 0: // Chiffre
     ui->stackedWidget->setCurrentIndex(1);
     break;
    case 1:  // Mémoire
     ui->stackedWidget->setCurrentIndex(1);
     break;
    case 2:  // Opérateur
        ui->stackedWidget->setCurrentIndex(2);
        break;
    case 3: // =
        ui->stackedWidget->setCurrentIndex(1);
        ui->leValeurEffective->setText("=");
        break;
    case 4:  // (
        ui->stackedWidget->setCurrentIndex(1);
        ui->leValeurEffective->setText("(");
        ui->leValeurAffichee->setText("(");
        break;
    case 5:  // )
        ui->stackedWidget->setCurrentIndex(1);
        ui->leValeurEffective->setText(")");
        ui->leValeurAffichee->setText(")");
        break;
    }
    EditeurTouche::activeChamps(index);
}
void EditeurTouche::activeChamps(int index)
{
    switch(index)
    {
    case 0:
        ui->leValeurAffichee->setDisabled(false);
        ui->leValeurEffective->setDisabled(false);
        break;
    case 1:
        ui->leValeurAffichee->setDisabled(false);
        ui->leValeurEffective->setDisabled(false);
        break;
    case 2:
        ui->leValeurAffichee->setDisabled(false);
        ui->leValeurEffective->setDisabled(false);
        break;

    case 3:
        ui->leValeurAffichee->setDisabled(true);
        ui->leValeurEffective->setDisabled(true);
        break;
    case 4:
        ui->leValeurAffichee->setDisabled(true);
        ui->leValeurEffective->setDisabled(true);
        break;
    case 5:
        ui->leValeurAffichee->setDisabled(true);
        ui->leValeurEffective->setDisabled(true);
        break;
    }
}
