/** Implémentation de la Calculette Capricieuse
 *
 * @see https://redmine.ryxeo.com/projects/leterrier-calc-cap/wiki
 * @author 2010 Jean-Louis Frucot
 * @see The GNU Public License (GPL)
 */

/**
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
* for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#ifndef EDITEURTOUCHE_H
#define EDITEURTOUCHE_H

#include <QDialog>
#include "mainwindow.h"
namespace Ui {
    class EditeurTouche;
}
/** L'éditeur de touches permet de modifier les paramètres stokés avec les QPushbutton correspondant.
  *Ces paramètres se trouvent dans les propiétés dynamiques : valeurEffective, nbFois, nbFoisRestant, typeTouche
  * @param typeTouche letype de touche : chiffre, memoire, operateur, egale
  * @param valeurAffichee valeur visible du bouton par exemple x pour la multiplication
  * @param valeurEffective valuer du bouton utilisée pour le calcul par exemple * pour la multiplication
  * @param nbFois nombre d'utilisations possibles de la touche de 0 à 10 ou 32000 (illimité)
  * @param parent
  * Les valeurs de retour sont dans fenetreEditeur->valAffichee, ->valEffective, ->nb, ->typeTouch
  */
class EditeurTouche : public QDialog {
    Q_OBJECT
public:
    EditeurTouche(QString &typeTouche, QString &valeurAffichee, QString &valeurEffective, int &nbFois, QWidget *parent = 0);
    ~EditeurTouche();
    QString valAffichee;
    QString valEffective;
    QString typeTouch;
    QString tabType[6];
    int nb;
protected:
    void changeEvent(QEvent *e);

private:
    Ui::EditeurTouche *ui;
    /** Active ou déactive les champs valeurAffichée et valeur Effective en fonction du type de Touche
      * @param index L'index du type de Touche (typeTouche[])
      */
    void activeChamps(int index);


private slots:
    void on_cbTypeTouche_currentIndexChanged(int index);
    void on_buttonBox_accepted();

};

#endif // EDITEURTOUCHE_H
