/*! \mainpage Calculette Capricieuse V2
 *
 * @author Jean-Louis Frucot
 * @date 11/08/2010
 *
 * \section intro_sec Introduction
 *
 * D'après une idée de David Lucardi, cette calculette offre la particularité d'avoir des touches paramétrables
 * - en Valeur affichée sur la touche
 * - en valeur effectivement utilisée pour le calcul
 * - en nombre d'utilisation possible de chaque touche
 * \section install_sec Installation
 *
 * \subsection step1 Récupérer les sources
 * https://redmine.ryxeo.com/projects/leterrier-calc-cap/repository
 * compiler
 * etc...
 * \subsection Licence
 * Implémentation de la Calculette Capricieuse
 *
 * @see https://redmine.ryxeo.com/projects/leterrier-calc-cap/wiki
 * @author 2010 Jean-Louis Frucot
 * @see The GNU Public License (GPL)
 *
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
* for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include <QtGui/QApplication>
#include "mainwindow.h"
#include <QTranslator>
#include <QLibraryInfo>
#include <QLocale>
#include <QDebug>
#include <QtPlugin>
#include "abuleduexercicev0.h"

//-------------------Nom visible de l'application---------------------
//
extern const QString abeApplicationLongName="Leterrier d'AbulEdu - Calculette capricieuse";
//
//--------------------------------------------------------------------


    /**
      * Calculette capricieuse : une calculette dont les touches sont paramétrables :
      * - en valeur Affichée,
      * - en valeur cachée,
      * - en nombre de possibilités d'utiliser chaque touche.
      */

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    // pour avoir les boutons des boîtes de dialogue dans la langue locale (fr par défaut)
    QTranslator qtTranslator;
    qtTranslator.load(
            "qt_" + QLocale::system().name(),
            QLibraryInfo::location(QLibraryInfo::TranslationsPath)
            );
    a.installTranslator(&qtTranslator);
    QString locale = QLocale::system().name().section('_', 0, 0);
        QTranslator translator;
        translator.load(QString("calc_") +locale,"lang/");
        a.installTranslator(&translator);
    qApp->setApplicationName("leterrier-calc-cap");
    qApp->setApplicationVersion("2.0.2");
    qApp->setOrganizationDomain("abuledu.org");
    qApp->setOrganizationName("leterrier");


    MainWindow w;
    w.show();
    return a.exec();
}


